function [index1,index2,optimal,tau_final] = find_best_pair(Y,etas,as,ds,alphas,only_I_M,fix_index,epsilon,tau)
% FBGL, Nov 03

% fix_index:  fix one of the two indexes already; if -1: this determines
% worst violating pair
% epsilon: for 0 and C check
% tau: for optimality check

global DKDa
global aDKDa
global I

[n m]= size(DKDa);

%I_M = and(alphas>=epsilon,alphas<=C-epsilon);
%I_0min = and(alphas<epsilon,Y==-1);
%I_0plus = and(alphas<epsilon,Y==1);
%I_Cmin = and(alphas>C-epsilon,Y==-1);
%I_Cplus = and(alphas>C-epsilon,Y==1);

if only_I_M,
    I_min = I.I_M;
    I_max = I.I_M;
else
    I_min = I.I_M| I.I_0plus| I.I_Cmin;
    I_max = I.I_M| I.I_0min| I.I_Cplus;
end
II_min=find(I_min);
II_max=find(I_max);


grad_Ga = -1 + DKDa*etas;
y_grad_Ga = Y.*grad_Ga;
[b_low,i_low] = max(y_grad_Ga(II_max));
i_low = II_max(i_low);
[b_up,i_up] = min(y_grad_Ga(II_min));
i_up = II_min(i_up);
tau_final = (b_low - b_up)/2;
optimal = (b_low <= b_up + 2*tau);



if fix_index==-1,
    index1 = i_low;
    index2 = i_up;
elseif I.I_M(fix_index),
    if b_low - y_grad_Ga(fix_index,1) > y_grad_Ga(fix_index,1) - b_up,
        index1 = i_low;
        index2 = fix_index;
    else
        index1 = fix_index;
        index2 = i_up;
    end
elseif I_max(fix_index),
    index1 = fix_index;
    index2 = i_up;
elseif I_min(fix_index),
    index1 = i_low;
    index2 = fix_index;
end
